<template>
  <div v-if="sr" class="super-reader-ctn">
    <h2
      class="block-title review-list-title"
      v-html="$t('serie.review_header', { count: serie.SRreviewCnt })"
    ></h2>
    <header class="review-header">
      <div class="user-avatar">
        <img :src="authorImg" />
      </div>
      <div class="review-header-content2">
        <div class="review-type" itemprop="name">
          {{ $t('serie.superreader') }}
        </div>
        <div class="user-name">
          <a class="user-name-link" itemprop="author" :href="authorUrl">{{
            authorName
          }}</a>
        </div>
      </div>
    </header>
    <div class="sr-comment-ctn" :class="{ 'is-open': !isTruncated }">
      <p class="sr-comment" v-html="truncateDesc"></p>
      <footer
        class="review-footer"
        itemprop="reviewRating"
        itemscope=""
        itemtype="http://schema.org/Rating"
      >
        <a
          v-if="needTruncate"
          class="read-more"
          href="#review-read-more"
          @click="isTruncated = !isTruncated"
          >{{ $t('common.continue') }}</a
        >
      </footer>
    </div>
    <div class="footer">
      <div class="all-reviews">
        <a :href="albumUrl">{{ $t('common.allReviews') }}</a>
      </div>
      <StarRank
        is-mini="false"
        class="rate"
        :avgstar="serie.rate"
        :countnote="serie.rateAmount"
      />
    </div>
  </div>
</template>

<script>
import StarRank from '~/components/ui/StarRank'

export default {
  components: { StarRank },
  props: {
    sr: {
      type: Object,
      required: true
    },
    serie: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      isTruncated: true,
      author: undefined
    }
  },
  computed: {
    albumUrl() {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/${this.serie.shelf}/${this.serie.genre}/${this.serie.slug}/${this.sr.album.slug}-${this.sr.album.id}`
    },
    commentUrl() {
      return `${this.albumUrl}#comment`
    },
    truncatedReview() {
      return this.$utils.cutByWords(this.sr.review || '', 440)
    },
    truncateDesc() {
      let text = this.sr.review || ''

      if (this.isTruncated) {
        text = this.truncatedReview
      }

      return text
    },
    needTruncate() {
      return this.sr.review && this.sr.review !== this.truncatedReview
    },
    authorName() {
      return this.sr.login
    },
    authorImg() {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/images/avatar/${this.sr.id}.jpg`
    },
    authorUrl() {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/profil/${this.sr.id}`
    }
  },
  mounted() {
    this.isTruncated = this.needTruncate
  }
}
</script>

<style lang="scss" scoped>
.super-reader-ctn {
  display: flex;
  flex-direction: column;

  .block-title {
    font-size: 26px;
    width: 100%;
    float: left;
    padding-top: 20px;
    border-top: 2px solid #3e3e3e;
    text-align: left;
  }
}

.review-header {
  text-align: left;
  margin-bottom: 10px;

  .user-avatar {
    display: block;
    position: absolute;
    width: 80px;
    height: 80px;
    z-index: 1;

    img {
      display: block;
      position: relative;
      left: 50%;
      transform: translateX(-50%);
      width: 100%;
      max-width: 100%;
      height: auto;
    }
  }
}

.review-header-content2 {
  display: flex;
  flex-direction: column;
  height: 80px;
  margin-left: 60px;
  padding: 10px 10px 10px 40px;
  font-size: 14px;
  font-size: 1rem;
  justify-content: center;
  background: #ededed;
}

.super-reader {
  flex: 1;
  display: flex;

  .author-img {
    width: 100%;

    img {
      width: 85px;
      height: auto;
      border-radius: 99999px;
      margin: auto;
      display: inherit;
    }
  }

  .author-info {
    text-align: center;
  }

  .author-name {
    font-size: 14px;
    color: #808080;
  }
}

.sr-comment-ctn {
  text-align: left;
  border-bottom: 1px solid #ededed;
  padding: 15px 0;

  .review-footer {
    margin: 15px 0;
  }

  .read-more {
    cursor: pointer;
    text-decoration: none;
    color: #686868;

    &:hover {
      color: $color-secondary;
    }
  }
}

.footer {
  text-align: left;
  padding-top: 31px;

  .all-reviews {
    display: inline-block;
    font-family: 'DINCond', sans-serif;
    font-size: 17px;
    font-weight: 600;
    text-transform: uppercase;
    color: #808080;
  }

  .rate {
    float: right;
  }
}
</style>
